/*
 *  for MB9BF618T on FRK-FM3
 * 
 *   Copyright (C) by Y.Ishioka.
 */
#ifndef  __FM3_H__
#define  __FM3_H__

/** fm3_wait **/
void  WaitMsec( unsigned int msec ) ;
void  WaitUsec( unsigned int usec ) ;
void  WaitNsec( unsigned int nsec ) ;

/** fm3_lcd **/
void  LCD_put4bit( unsigned int data, unsigned int rs );
void  lcd_putchar( unsigned int data, unsigned int rs );
void  lcd_putstr( char *buf, unsigned int line );
void  lcd_clear( void );
void  lcd_init( void );

/** fm3_io **/
void  switch_init( unsigned int bit );
int  switch_read( unsigned int bit );

/** fm3_io **/
void  uart_send( int port, unsigned char data ) ;
int  uart_recv( int port );
void  uart_putstring( int port, unsigned char *buf );
void  uart_chg_baud( int port, unsigned int baud );
void  uart_init( int port );

/** led **/
void  led_init( int num );
void  led_set( int num, unsigned int led );


#endif /* __FM3_H__ */
