/*
 *  for MB9BF618T on FRK-FM3
 * 
 *   Copyright (C) by Y.Ishioka.
 */
#include "mb9b610t.h"
#include "fm3.h"

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
extern "C" {
#endif
/**INDENT-ON**/
/// @endcond


/***********************************************************/
void  WaitMsec( unsigned int  msec )
{
    unsigned int   tmp ;

    if( msec == 0 ) {
        return ;
    }

    tmp = msec * 10 * 1000 ;

    __asm__( "loop_waitmsec: \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       subs  %0, #1 \n"
         "       bne.n loop_waitmsec"
         :
         : "r" (tmp)
    ) ;
}


/***********************************************************/
void  WaitUsec( unsigned int usec )
{
    unsigned int  tmp ;

    if( usec == 0 ) {
        return ;
    }

    tmp = usec * 10 ;

    __asm__( "loop_waitusec: \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       subs  %0, #1 \n"
         "       bne.n loop_waitusec"
         :
         : "r" (tmp)
    ) ;
}


/***********************************************************/
void  WaitNsec( unsigned int nsec )
{
    unsigned int  tmp ;

    if( nsec == 0 ) {
        return ;
    }

    if( (tmp=nsec/100)==0 ) {
        tmp = 1 ;
    }

    __asm__( "loop_waitnsec: \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       nop \n"
         "       subs  %0, #1 \n"
         "       bne.n loop_waitnsec"
         :
         : "r" (tmp)
    ) ;
}


//@}

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
}
#endif
/**INDENT-ON**/
/// @endcond
