/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: sample1.c 1797 2010-06-07 04:24:19Z ertl-hiro $
 */

/* 
 *  ץץ(1)
 *
 *  ASPͥδŪưǧ뤿Υץץࡥ
 *
 *  ץγ:
 *
 *  桼󥿥եĥᥤ󥿥ʥID: MAIN_TASKͥ
 *  : MAIN_PRIORITYˤȡ3Ĥ¹Ԥ륿ʥID:
 *  TASK1TASK3ͥ: MID_PRIORITYˤǹ롥ޤư
 *  2äμϥɥʼϥɥID: CYCHDR1ˤѤ롥
 *
 *  ¹Ԥ륿ϡtask_loop롼פ¹Ԥ٤ˡ
 *  ¹Ǥ뤳Ȥ򤢤魯åɽ롥
 *
 *  ϥɥϡĤͥ١HIGH_PRIORITYMID_PRIORITY
 *  LOW_PRIORITYˤΥǥ塼ž롥ץεưľϡ
 *  ϥɥ߾֤ˤʤäƤ롥
 *
 *  ᥤ󥿥ϡꥢI/OݡȤʸϤԤʸϤ
 *  ԤäƤ֤ϡ¹Ԥ륿¹ԤƤˡϤ줿
 *  ʸб¹Ԥ롥Ϥ줿ʸȽδطϼ̤ꡥ
 *  Control-Cޤ'Q'Ϥȡץλ롥
 *
 *  '1' : оݥTASK1ڤ괹ʽˡ
 *  '2' : оݥTASK2ڤ괹롥
 *  '3' : оݥTASK3ڤ괹롥
 *  'a' : оݥact_tskˤ굯ư롥
 *  'A' : оݥФ뵯ư׵can_actˤꥭ󥻥뤹롥
 *  'e' : оݥext_tskƤӽФλ롥
 *  't' : оݥter_tskˤ궯λ롥
 *  '>' : оݥͥ٤HIGH_PRIORITYˤ롥
 *  '=' : оݥͥ٤MID_PRIORITYˤ롥
 *  '<' : оݥͥ٤LOW_PRIORITYˤ롥
 *  'G' : оݥͥ٤get_priɤ߽Ф
 *  's' : оݥslp_tskƤӽФԤˤ롥
 *  'S' : оݥtslp_tsk(10)ƤӽФԤˤ롥
 *  'w' : оݥwup_tskˤ굯롥
 *  'W' : оݥФ뵯׵can_wupˤꥭ󥻥뤹롥
 *  'l' : оݥrel_waiˤ궯ŪԤˤ롥
 *  'u' : оݥsus_tskˤ궯Ԥ֤ˤ롥
 *  'm' : оݥζԤ֤rsm_tskˤ롥
 *  'd' : оݥdly_tsk(10)ƤӽФַвԤˤ롥
 *  'x' : оݥ㳰ѥ0x0001㳰׵᤹롥
 *  'X' : оݥ㳰ѥ0x0002㳰׵᤹롥
 *  'y' : оݥdis_texƤӽФ㳰ػߤ롥
 *  'Y' : оݥena_texƤӽФ㳰Ĥ롥
 *  'r' : 3Ĥͥ١HIGH_PRIORITYMID_PRIORITYLOW_PRIORITYˤΥ
 *        ǥ塼ž롥
 *  'c' : ϥɥưϤ롥
 *  'C' : ϥɥưߤ롥
 *  'b' : 顼ϥɥ5ø˵ư褦ưϤ롥
 *  'B' : 顼ϥɥưߤ롥
 *  'z' : оݥCPU㳰ȯʥλˡ
 *  'Z' : оݥCPUå֤CPU㳰ȯʥץ
 *        λˡ
 *  'V' : get_utmǽɾѥƥ2ɤࡥ
 *  'v' : ȯԤƥॳɽʥǥեȡˡ
 *  'q' : ȯԤƥॳɽʤ
 */

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "sample1.h"


/** added by Y.Ishioka **/
void  led_init( int num );
void  led_set( int num, unsigned int led );
/** added by Y.Ishioka **/


/** added by Y.Ishioka **/
unsigned long  tran_get_tim( void )
{
    SYSTIM  p_systim ;
    (void)get_tim( &p_systim ) ;

    return( (unsigned long)p_systim ) ;
}

void  tran_delay( unsigned long  ms )
{
    (void)dly_tsk( (RELTIM)ms ) ;
}
/** added by Y.Ishioka **/


/*
 *  ӥΥ顼Υ
 */
Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))

/*
 *  ¹Լ¹Ԥ륿ؤΥåΰ
 */
char_t	message[3];

/*
 *  롼ײ
 */
ulong_t	task_loop;		/* ǤΥ롼ײ */
ulong_t	tex_loop;		/* 㳰롼ǤΥ롼ײ */
void (*atot_task_func_p)(void) ;
void (*atot_handler_func_p)(void) ;

void  main( void ) ;

/*
 *  ARDUINO TASK-A
 *     added by Y.Ishioka
 */
void  arduino_task( intptr_t exinf )
{
	atot_task_func_p = (void *)0 ;

	SVC_PERROR(ena_tex());

	/* go arduino routine */
	main() ;

	/* exit Arduino mode */
	while (1) {
		dly_tsk( 1 ) ;
	}
}


/*
 *  ARDUINO TASK-B
 *     added by Y.Ishioka
 */
void  arduino_regtask( intptr_t exinf )
{
	SVC_PERROR(ena_tex());

	while (1) {
		if( atot_task_func_p != (void *)0 ) {
			(*atot_task_func_p)() ;

			/* clear multi-task mode */
			atot_task_func_p = (void *)0 ;
		}
		dly_tsk( 10 ) ;
	}
}


/*
 *  ¹Լ¹Ԥ륿
 */
void task(intptr_t exinf)
{
	int_t		tskno = (int_t) exinf;

	SVC_PERROR(ena_tex());
	while (1) {
		dly_tsk( 10 ) ;
	}
}

/*
 *  ¹ԤƼ¹Ԥ륿ѤΥ㳰롼
 */
void tex_routine(TEXPTN texptn, intptr_t exinf)
{
	volatile ulong_t	i;
	int_t	tskno = (int_t) exinf;

	syslog(LOG_NOTICE, "task%d receives exception 0x%04x.", tskno, texptn);
	for (i = 0; i < tex_loop; i++);

	if ((texptn & 0x8000U) != 0U) {
		syslog(LOG_INFO, "#%d#ext_tsk()", tskno);
		SVC_PERROR(ext_tsk());
		assert(0);
	}
}

/*
 *  CPU㳰ϥɥ
 */
#ifdef CPUEXC1

void
cpuexc_handler(void *p_excinf)
{
	ID		tskid;

	syslog(LOG_NOTICE, "CPU exception handler (p_excinf = %08p).", p_excinf);
	if (sns_ctx() != true) {
		syslog(LOG_WARNING,
					"sns_ctx() is not true in CPU exception handler.");
	}
	if (sns_dpn() != true) {
		syslog(LOG_WARNING,
					"sns_dpn() is not true in CPU exception handler.");
	}
	syslog(LOG_INFO, "sns_loc = %d sns_dsp = %d sns_tex = %d",
									sns_loc(), sns_dsp(), sns_tex());
	syslog(LOG_INFO, "xsns_dpn = %d xsns_xpn = %d",
									xsns_dpn(p_excinf), xsns_xpn(p_excinf));

	if (xsns_xpn(p_excinf)) {
		syslog(LOG_NOTICE, "Sample program ends with exception.");
		SVC_PERROR(ext_ker());
		assert(0);
	}

	SVC_PERROR(iget_tid(&tskid));
	SVC_PERROR(iras_tex(tskid, 0x8000U));
}

#endif /* CPUEXC1 */

/*
 *  ϥɥ
 *
 *  HIGH_PRIORITYMID_PRIORITYLOW_PRIORITY γͥ٤Υǥ塼
 *  ž롥
 */
void cyclic_handler(intptr_t exinf)
{
	SVC_PERROR(irot_rdq(HIGH_PRIORITY));
	SVC_PERROR(irot_rdq(MID_PRIORITY));
	SVC_PERROR(irot_rdq(LOW_PRIORITY));

	if( atot_handler_func_p != (void *)0 ) {
		(*atot_handler_func_p)() ;
	}
}

/*
 *  顼ϥɥ
 *
 *  HIGH_PRIORITYMID_PRIORITYLOW_PRIORITY γͥ٤Υǥ塼
 *  ž롥
 */
void alarm_handler(intptr_t exinf)
{
	SVC_PERROR(irot_rdq(HIGH_PRIORITY));
	SVC_PERROR(irot_rdq(MID_PRIORITY));
	SVC_PERROR(irot_rdq(LOW_PRIORITY));
}

/*
 *  ᥤ󥿥
 */
void main_task(intptr_t exinf)
{
	ER_UINT	ercd;
#ifndef TASK_LOOP
	volatile ulong_t	i;
	SYSTIM	stime1, stime2;
#endif /* TASK_LOOP */

/** added by Y.Ishioka **/
	int count = 0;
/** added by Y.Ishioka **/

	SVC_PERROR(syslog_msk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG)));
	syslog(LOG_NOTICE, "Sample program starts (exinf = %d).", (int_t) exinf);

	/*
	 *  ꥢݡȤν
	 *
	 *  ƥƱꥢݡȤȤʤɡꥢ
	 *  ݡȤץѤߤξˤϤE_OBJ顼ˤʤ뤬پ
	 *  ʤ
	 */
	ercd = serial_opn_por(TASK_PORTID);
	if (ercd < 0 && MERCD(ercd) != E_OBJ) {
		syslog(LOG_ERROR, "%s (%d) reported by `serial_opn_por'.",
									itron_strerror(ercd), SERCD(ercd));
	}
	SVC_PERROR(serial_ctl_por(TASK_PORTID,
							(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));

	/*
 	 *  롼ײ
	 *
	 *  TASK_LOOPޥƤ硤¬ꤻˡTASK_LOOP
	 *  줿ͤ򡤥ǤΥ롼ײȤ롥
	 *
	 *  MEASURE_TWICEޥƤ硤1ܤ¬̤Τ
	 *  ơ2ܤ¬̤Ȥ1ܤ¬Ĺλ֤Ф뤿ᡥ
	 */
#ifdef TASK_LOOP
	task_loop = TASK_LOOP;
#else /* TASK_LOOP */

#ifdef MEASURE_TWICE
	task_loop = LOOP_REF;
	SVC_PERROR(get_tim(&stime1));
	for (i = 0; i < task_loop; i++);
	SVC_PERROR(get_tim(&stime2));
#endif /* MEASURE_TWICE */

	task_loop = LOOP_REF;
	SVC_PERROR(get_tim(&stime1));
	for (i = 0; i < task_loop; i++);
	SVC_PERROR(get_tim(&stime2));
	task_loop = LOOP_REF * 400UL / (stime2 - stime1);

#endif /* TASK_LOOP */
	tex_loop = task_loop / 5;

	/** added by Y.Ishioka **/
	atot_task_func_p = (void *)0 ;
	atot_handler_func_p = (void *)0 ;
	/** added by Y.Ishioka **/

	/*
 	 *  εư
	 */
	SVC_PERROR(act_tsk(TASK1));
	SVC_PERROR(act_tsk(TASK2));
	SVC_PERROR(act_tsk(TASK3));

	/** added by Y.Ishioka **/
	sta_cyc( CYCHDR1 ) ;
	/** added by Y.Ishioka **/

#if 0  /* for TEST by Y.Ishioka */
	lcd_gra_init() ;
#endif /* for TEST by Y.Ishioka */

/** added by Y.Ishioka **/
	led_init( 0 ) ;
/** added by Y.Ishioka **/

	/*
 	 *  ᥤ롼
	 */
	while (1) {
#if 0  /* for TEST by Y.Ishioka */
		maze_main() ;
#endif /* for TEST by Y.Ishioka */

/** added by Y.Ishioka **/
		if( (count & 0x0001) != 0 ) {
			led_set( 0, 1 ) ; /* LED on */
		} else {
			led_set( 0, 0 ) ; /* LED off */
		}
		count++ ;
/** added by Y.Ishioka **/

		dly_tsk( 500 ) ;
	}
}
